#!/bin/bash

# Script que testa o hello. Esse é só um exemplo, existem inúmeras ferramentas de testes
# por aí, procure não reinventar a roda.

BIN="build/hello"

# Testa se arquivo existe e é executável
if ! test -x $BIN; then
    echo "Binário inexistente"
    exit 1
fi

# Testa código de retorno
res=$(./$BIN)
ret=$?
echo -n "Testando código de retorno... "
if test $ret -ne 0; then
    echo "ERRO: Programa retornou erro $ret: $res"
    exit 1
fi
echo "OK"

# Testa valor de retorno
expected="hello world"
echo -n "Testando valor de retorno... "
if test "$res" != "$expected"; then
    echo "ERRO: Programa deveria retornar $expected, mas retornou \"$res\"."
    exit 1
fi
echo "OK"

# Se chegou até aqui, sucesso!
echo "Todos os testes passaram!"

exit 0
